KCAPI_AKCIPHER_ENCRY(3)

NAME
kcapi_akcipher_encrypt - encrypt data

SYNOPSIS

int32_t kcapi_akcipher_encrypt(struct kcapi_handle * handle, const uint8_t * in, uint32_t inlen, uint8_t * out, uint32_t outlen, int access);

ARGUMENTS

handle
    [in] cipher handle

in
    [in] plaintext data buffer

inlen
    [in] length of in buffer

out
    [out] ciphertext data buffer

outlen
    [in] length of out buffer

access
    [in] kernel access type (KCAPI_ACCESS_HEURISTIC - use internal heuristic for fastest kernel access; KCAPI_ACCESS_VMSPLICE - use vmsplice access; KCAPI_ACCESS_SENDMSG - sendmsg access)

DESCRIPTION

It is perfectly legal to use the same buffer as the plaintext and ciphertext pointers. That would mean that after the encryption operation, the plaintext is overwritten with the ciphertext.

The memory should be aligned at the page boundary using posix_memalign(sysconf(_SC_PAGESIZE)), If it is not aligned at the page boundary, the vmsplice call may not send all data to the kernel.

If the output size is insufficiently large, -EINVAL is returned. The output buffer must be at least as large as the modululs of the uses key.

return number of bytes returned by the encryption operation upon success; a negative errno-style error code if an error occurred

AUTHOR

Stephan Mueller <smueller@chronox.de>
    Author.

COPYRIGHT